diff -Nru astroid-1.6.5/astroid/brain/brain_six.py astroid-2.0/astroid/brain/brain_six.py
--- astroid-1.6.5/astroid/brain/brain_six.py	2018-06-06 16:59:26.000000000 +0200
+++ astroid-2.0/astroid/brain/brain_six.py	2018-07-15 09:19:27.000000000 +0200
@@ -1,4 +1,6 @@
-# Copyright (c) 2014-2016 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2014-2016, 2018 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2015-2016 Ceridwen <ceridwenv@gmail.com>
+# Copyright (c) 2018 Bryce Guinta <bryce.paul.guinta@gmail.com>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
@@ -6,7 +8,6 @@
 
 """Astroid hooks for six module."""
 
-import sys
 from textwrap import dedent
 
 from astroid import MANAGER, register_module_extender
@@ -35,202 +36,69 @@
     return ''.join(prefixed_lines())
 
 
-if sys.version_info[0] == 2:
-    _IMPORTS_2 = """
-    import BaseHTTPServer
-    import CGIHTTPServer
-    import SimpleHTTPServer
-
-    from StringIO import StringIO
-    from cStringIO import StringIO as cStringIO
-    from UserDict import UserDict
-    from UserList import UserList
-    from UserString import UserString
-
-    import __builtin__ as builtins
-    import thread as _thread
-    import dummy_thread as _dummy_thread
-    import ConfigParser as configparser
-    import copy_reg as copyreg
-    from itertools import (imap as map,
-                           ifilter as filter,
-                           ifilterfalse as filterfalse,
-                           izip_longest as zip_longest,
-                           izip as zip)
-    import htmlentitydefs as html_entities
-    import HTMLParser as html_parser
-    import httplib as http_client
-    import cookielib as http_cookiejar
-    import Cookie as http_cookies
-    import Queue as queue
-    import repr as reprlib
-    from pipes import quote as shlex_quote
-    import SocketServer as socketserver
-    import SimpleXMLRPCServer as xmlrpc_server
-    import xmlrpclib as xmlrpc_client
-    import _winreg as winreg
-    import robotparser as urllib_robotparser
-    import Tkinter as tkinter
-    import tkFileDialog as tkinter_tkfiledialog
-
-    input = raw_input
-    intern = intern
-    range = xrange
-    xrange = xrange
-    reduce = reduce
-    reload_module = reload
-
-    class UrllibParse(object):
-        def __init__(self):
-            import urlparse as _urlparse
-            import urllib as _urllib
-
-            self.ParseResult = _urlparse.ParseResult
-            self.SplitResult = _urlparse.SplitResult
-            self.parse_qs = _urlparse.parse_qs
-            self.parse_qsl = _urlparse.parse_qsl
-            self.urldefrag = _urlparse.urldefrag
-            self.urljoin = _urlparse.urljoin
-            self.urlparse = _urlparse.urlparse
-            self.urlsplit = _urlparse.urlsplit
-            self.urlunparse = _urlparse.urlunparse
-            self.urlunsplit = _urlparse.urlunsplit
-            self.quote = _urllib.quote
-            self.quote_plus = _urllib.quote_plus
-            self.unquote = _urllib.unquote
-            self.unquote_plus = _urllib.unquote_plus
-            self.urlencode = _urllib.urlencode
-            self.splitquery = _urllib.splitquery
-            self.splittag = _urllib.splittag
-            self.splituser = _urllib.splituser
-            self.uses_fragment = _urlparse.uses_fragment
-            self.uses_netloc = _urlparse.uses_netloc
-            self.uses_params = _urlparse.uses_params
-            self.uses_query = _urlparse.uses_query
-            self.uses_relative = _urlparse.uses_relative
-
-    class UrllibError(object):
-        import urllib2 as _urllib2
-        import urllib as _urllib
-        URLError = _urllib2.URLError
-        HTTPError = _urllib2.HTTPError
-        ContentTooShortError = _urllib.ContentTooShortError
-
-    class DummyModule(object):
-        pass
-
-    class UrllibRequest(object):
-        def __init__(self):
-            import urlparse as _urlparse
-            import urllib2 as _urllib2
-            import urllib as _urllib
-            self.urlopen = _urllib2.urlopen
-            self.install_opener = _urllib2.install_opener
-            self.build_opener = _urllib2.build_opener
-            self.pathname2url = _urllib.pathname2url
-            self.url2pathname = _urllib.url2pathname
-            self.getproxies = _urllib.getproxies
-            self.Request = _urllib2.Request
-            self.OpenerDirector = _urllib2.OpenerDirector
-            self.HTTPDefaultErrorHandler = _urllib2.HTTPDefaultErrorHandler
-            self.HTTPRedirectHandler = _urllib2.HTTPRedirectHandler
-            self.HTTPCookieProcessor = _urllib2.HTTPCookieProcessor
-            self.ProxyHandler = _urllib2.ProxyHandler
-            self.BaseHandler = _urllib2.BaseHandler
-            self.HTTPPasswordMgr = _urllib2.HTTPPasswordMgr
-            self.HTTPPasswordMgrWithDefaultRealm = _urllib2.HTTPPasswordMgrWithDefaultRealm
-            self.AbstractBasicAuthHandler = _urllib2.AbstractBasicAuthHandler
-            self.HTTPBasicAuthHandler = _urllib2.HTTPBasicAuthHandler
-            self.ProxyBasicAuthHandler = _urllib2.ProxyBasicAuthHandler
-            self.AbstractDigestAuthHandler = _urllib2.AbstractDigestAuthHandler
-            self.HTTPDigestAuthHandler = _urllib2.HTTPDigestAuthHandler
-            self.ProxyDigestAuthHandler = _urllib2.ProxyDigestAuthHandler
-            self.HTTPHandler = _urllib2.HTTPHandler
-            self.HTTPSHandler = _urllib2.HTTPSHandler
-            self.FileHandler = _urllib2.FileHandler
-            self.FTPHandler = _urllib2.FTPHandler
-            self.CacheFTPHandler = _urllib2.CacheFTPHandler
-            self.UnknownHandler = _urllib2.UnknownHandler
-            self.HTTPErrorProcessor = _urllib2.HTTPErrorProcessor
-            self.urlretrieve = _urllib.urlretrieve
-            self.urlcleanup = _urllib.urlcleanup
-            self.proxy_bypass = _urllib.proxy_bypass
-
-    urllib_parse = UrllibParse()
-    urllib_error = UrllibError()
-    urllib = DummyModule()
-    urllib.request = UrllibRequest()
-    urllib.parse = UrllibParse()
-    urllib.error = UrllibError()
-    """
-else:
-    _IMPORTS_3 = """
-    import _io
-    cStringIO = _io.StringIO
-    filter = filter
-    from itertools import filterfalse
-    input = input
-    from sys import intern
-    map = map
-    range = range
-    from imp import reload as reload_module
-    from functools import reduce
-    from shlex import quote as shlex_quote
-    from io import StringIO
-    from collections import UserDict, UserList, UserString
-    xrange = range
-    zip = zip
-    from itertools import zip_longest
-    import builtins
-    import configparser
-    import copyreg
-    import _dummy_thread
-    import http.cookiejar as http_cookiejar
-    import http.cookies as http_cookies
-    import html.entities as html_entities
-    import html.parser as html_parser
-    import http.client as http_client
-    import http.server as http_server
-    BaseHTTPServer = CGIHTTPServer = SimpleHTTPServer = http.server
-    import pickle as cPickle
-    import queue
-    import reprlib
-    import socketserver
-    import _thread
-    import winreg
-    import xmlrpc.server as xmlrpc_server
-    import xmlrpc.client as xmlrpc_client
-    import urllib.robotparser as urllib_robotparser
-    import email.mime.multipart as email_mime_multipart
-    import email.mime.nonmultipart as email_mime_nonmultipart
-    import email.mime.text as email_mime_text
-    import email.mime.base as email_mime_base
-    import urllib.parse as urllib_parse
-    import urllib.error as urllib_error
-    import tkinter
-    import tkinter.dialog as tkinter_dialog
-    import tkinter.filedialog as tkinter_filedialog
-    import tkinter.scrolledtext as tkinter_scrolledtext
-    import tkinter.simpledialog as tkinder_simpledialog
-    import tkinter.tix as tkinter_tix
-    import tkinter.ttk as tkinter_ttk
-    import tkinter.constants as tkinter_constants
-    import tkinter.dnd as tkinter_dnd
-    import tkinter.colorchooser as tkinter_colorchooser
-    import tkinter.commondialog as tkinter_commondialog
-    import tkinter.filedialog as tkinter_tkfiledialog
-    import tkinter.font as tkinter_font
-    import tkinter.messagebox as tkinter_messagebox
-    import urllib
-    import urllib.request as urllib_request
-    import urllib.robotparser as urllib_robotparser
-    import urllib.parse as urllib_parse
-    import urllib.error as urllib_error
-    """
-if sys.version_info[0] == 2:
-    _IMPORTS = dedent(_IMPORTS_2)
-else:
-    _IMPORTS = dedent(_IMPORTS_3)
+_IMPORTS = """
+import _io
+cStringIO = _io.StringIO
+filter = filter
+from itertools import filterfalse
+input = input
+from sys import intern
+map = map
+range = range
+from imp import reload as reload_module
+from functools import reduce
+from shlex import quote as shlex_quote
+from io import StringIO
+from collections import UserDict, UserList, UserString
+xrange = range
+zip = zip
+from itertools import zip_longest
+import builtins
+import configparser
+import copyreg
+import _dummy_thread
+import http.cookiejar as http_cookiejar
+import http.cookies as http_cookies
+import html.entities as html_entities
+import html.parser as html_parser
+import http.client as http_client
+import http.server as http_server
+BaseHTTPServer = CGIHTTPServer = SimpleHTTPServer = http.server
+import pickle as cPickle
+import queue
+import reprlib
+import socketserver
+import _thread
+import winreg
+import xmlrpc.server as xmlrpc_server
+import xmlrpc.client as xmlrpc_client
+import urllib.robotparser as urllib_robotparser
+import email.mime.multipart as email_mime_multipart
+import email.mime.nonmultipart as email_mime_nonmultipart
+import email.mime.text as email_mime_text
+import email.mime.base as email_mime_base
+import urllib.parse as urllib_parse
+import urllib.error as urllib_error
+import tkinter
+import tkinter.dialog as tkinter_dialog
+import tkinter.filedialog as tkinter_filedialog
+import tkinter.scrolledtext as tkinter_scrolledtext
+import tkinter.simpledialog as tkinder_simpledialog
+import tkinter.tix as tkinter_tix
+import tkinter.ttk as tkinter_ttk
+import tkinter.constants as tkinter_constants
+import tkinter.dnd as tkinter_dnd
+import tkinter.colorchooser as tkinter_colorchooser
+import tkinter.commondialog as tkinter_commondialog
+import tkinter.filedialog as tkinter_tkfiledialog
+import tkinter.font as tkinter_font
+import tkinter.messagebox as tkinter_messagebox
+import urllib
+import urllib.request as urllib_request
+import urllib.robotparser as urllib_robotparser
+import urllib.parse as urllib_parse
+import urllib.error as urllib_error
+"""
 
 
 def six_moves_transform():
@@ -248,7 +116,7 @@
     """Fix six.moves imports due to the dynamic nature of this
     class.
 
-    Construct a psuedo-module which contains all the nessecary imports
+    Construct a pseudo-module which contains all the necessary imports
     for six
 
     :param modname: Name of failed module
@@ -279,6 +147,19 @@
     # This will cause an Uninferable result, which is okay
     return module
 
+
+def _looks_like_decorated_with_six_add_metaclass(node):
+    if not node.decorators:
+        return False
+
+    for decorator in node.decorators.nodes:
+        if not isinstance(decorator, nodes.Call):
+            continue
+        if decorator.func.as_string() == SIX_ADD_METACLASS:
+            return True
+    return False
+
+
 def transform_six_add_metaclass(node):
     """Check if the given class node is decorated with *six.add_metaclass*
 
@@ -305,4 +186,8 @@
 register_module_extender(MANAGER, 'requests.packages.urllib3.packages.six',
                          six_moves_transform)
 MANAGER.register_failed_import_hook(_six_fail_hook)
-MANAGER.register_transform(nodes.ClassDef, transform_six_add_metaclass)
+MANAGER.register_transform(
+    nodes.ClassDef,
+    transform_six_add_metaclass,
+    _looks_like_decorated_with_six_add_metaclass,
+)
diff -Nru astroid-1.6.5/astroid/brain/brain_ssl.py astroid-2.0/astroid/brain/brain_ssl.py
--- astroid-1.6.5/astroid/brain/brain_ssl.py	2018-01-07 11:53:49.000000000 +0100
+++ astroid-2.0/astroid/brain/brain_ssl.py	2018-07-15 09:19:27.000000000 +0200
@@ -1,4 +1,5 @@
 # Copyright (c) 2016 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2016 Ceridwen <ceridwenv@gmail.com>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
diff -Nru astroid-1.6.5/astroid/brain/brain_subprocess.py astroid-2.0/astroid/brain/brain_subprocess.py
--- astroid-1.6.5/astroid/brain/brain_subprocess.py	2018-06-06 16:59:26.000000000 +0200
+++ astroid-2.0/astroid/brain/brain_subprocess.py	2018-07-15 09:19:27.000000000 +0200
@@ -1,4 +1,6 @@
-# Copyright (c) 2016 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2016-2017 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2017 Hugo <hugovk@users.noreply.github.com>
+# Copyright (c) 2018 Bryce Guinta <bryce.paul.guinta@gmail.com>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
@@ -13,6 +15,7 @@
 
 PY34 = sys.version_info >= (3, 4)
 PY36 = sys.version_info >= (3, 6)
+PY33 = sys.version_info >= (3, 3)
 
 
 def _subprocess_transform():
@@ -62,10 +65,14 @@
         '''
     else:
         ctx_manager = ''
+    py3_args = ""
+    if PY33:
+        py3_args = "args = []"
     code = textwrap.dedent('''
     class Popen(object):
         returncode = pid = 0
         stdin = stdout = stderr = file()
+        %(py3_args)s
 
         %(communicate_signature)s:
             return %(communicate)r
@@ -83,7 +90,9 @@
        ''' % {'communicate': communicate,
               'communicate_signature': communicate_signature,
               'wait_signature': wait_signature,
-              'ctx_manager': ctx_manager})
+              'ctx_manager': ctx_manager,
+              'py3_args': py3_args,
+              })
 
     init_lines = textwrap.dedent(init).splitlines()
     indented_init = '\n'.join([' ' * 4 + line for line in init_lines])
diff -Nru astroid-1.6.5/astroid/brain/brain_threading.py astroid-2.0/astroid/brain/brain_threading.py
--- astroid-1.6.5/astroid/brain/brain_threading.py	2018-05-13 12:38:38.000000000 +0200
+++ astroid-2.0/astroid/brain/brain_threading.py	2018-07-15 09:19:27.000000000 +0200
@@ -1,4 +1,6 @@
+# -*- coding: utf-8 -*-
 # Copyright (c) 2016 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2017 Łukasz Rogalski <rogalski.91@gmail.com>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
diff -Nru astroid-1.6.5/astroid/brain/brain_typing.py astroid-2.0/astroid/brain/brain_typing.py
--- astroid-1.6.5/astroid/brain/brain_typing.py	2018-06-06 16:59:26.000000000 +0200
+++ astroid-2.0/astroid/brain/brain_typing.py	2018-07-15 09:19:28.000000000 +0200
@@ -1,97 +1,97 @@
-# Copyright (c) 2016 David Euresti <david@dropbox.com>
+# -*- coding: utf-8 -*-
+# Copyright (c) 2017-2018 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2017 Łukasz Rogalski <rogalski.91@gmail.com>
+# Copyright (c) 2017 David Euresti <github@euresti.com>
+# Copyright (c) 2018 Bryce Guinta <bryce.paul.guinta@gmail.com>
 
 """Astroid hooks for typing.py support."""
-import textwrap
+import typing
 
 from astroid import (
-    MANAGER, UseInferenceDefault, extract_node, inference_tip,
-    nodes, InferenceError)
-from astroid.nodes import List, Tuple
+    MANAGER,
+    UseInferenceDefault,
+    extract_node,
+    inference_tip,
+    nodes,
+    InferenceError,
+)
 
 
 TYPING_NAMEDTUPLE_BASENAMES = {
     'NamedTuple',
     'typing.NamedTuple'
 }
+TYPING_TYPEVARS = {'TypeVar', 'NewType'}
+TYPING_TYPEVARS_QUALIFIED = {'typing.TypeVar', 'typing.NewType'}
+TYPING_TYPE_TEMPLATE = """
+class Meta(type):
+    def __getitem__(self, item):
+        return self
+
+class {0}(metaclass=Meta):
+    pass
+"""
+TYPING_MEMBERS = set(typing.__all__)
 
 
-def infer_typing_namedtuple(node, context=None):
-    """Infer a typing.NamedTuple(...) call."""
-    # This is essentially a namedtuple with different arguments
-    # so we extract the args and infer a named tuple.
-    try:
-        func = next(node.func.infer())
-    except InferenceError:
-        raise UseInferenceDefault
+def looks_like_typing_typevar_or_newtype(node):
+    func = node.func
+    if isinstance(func, nodes.Attribute):
+        return func.attrname in TYPING_TYPEVARS
+    if isinstance(func, nodes.Name):
+        return func.name in TYPING_TYPEVARS
+    return False
 
-    if func.qname() != 'typing.NamedTuple':
-        raise UseInferenceDefault
 
-    if len(node.args) != 2:
-        raise UseInferenceDefault
+def infer_typing_typevar_or_newtype(node, context=None):
+    """Infer a typing.TypeVar(...) or typing.NewType(...) call"""
+    try:
+        func = next(node.func.infer(context=context))
+    except InferenceError as exc:
+        raise UseInferenceDefault from exc
 
-    if not isinstance(node.args[1], (List, Tuple)):
+    if func.qname() not in TYPING_TYPEVARS_QUALIFIED:
+        raise UseInferenceDefault
+    if not node.args:
         raise UseInferenceDefault
 
-    names = []
-    for elt in node.args[1].elts:
-        if not isinstance(elt, (List, Tuple)):
-            raise UseInferenceDefault
-        if len(elt.elts) != 2:
-            raise UseInferenceDefault
-        names.append(elt.elts[0].as_string())
-
-    typename = node.args[0].as_string()
-    node = extract_node('namedtuple(%(typename)s, (%(fields)s,)) ' %
-        {'typename': typename, 'fields': ",".join(names)})
+    typename = node.args[0].as_string().strip("'")
+    node = extract_node(TYPING_TYPE_TEMPLATE.format(typename))
     return node.infer(context=context)
 
 
-def infer_typing_namedtuple_class(node, context=None):
-    """Infer a subclass of typing.NamedTuple"""
-
-    # Check if it has the corresponding bases
-    annassigns_fields = [
-        annassign.target.name for annassign in node.body
-        if isinstance(annassign, nodes.AnnAssign)
-    ]
-    code = textwrap.dedent('''
-    from collections import namedtuple
-    namedtuple({typename!r}, {fields!r})
-    ''').format(
-        typename=node.name,
-        fields=",".join(annassigns_fields)
-    )
-    node = extract_node(code)
-    return node.infer(context=context)
-
+def _looks_like_typing_subscript(node):
+    """Try to figure out if a Subscript node *might* be a typing-related subscript"""
+    if isinstance(node, nodes.Name):
+        return node.name in TYPING_MEMBERS
+    elif isinstance(node, nodes.Attribute):
+        return node.attrname in TYPING_MEMBERS
+    elif isinstance(node, nodes.Subscript):
+        return _looks_like_typing_subscript(node.value)
+    return False
 
-def has_namedtuple_base(node):
-    """Predicate for class inference tip
 
-    :type node: ClassDef
-    :rtype: bool
-    """
-    return set(node.basenames) & TYPING_NAMEDTUPLE_BASENAMES
+def infer_typing_attr(node, context=None):
+    """Infer a typing.X[...] subscript"""
+    try:
+        value = next(node.value.infer())
+    except InferenceError as exc:
+        raise UseInferenceDefault from exc
 
+    if not value.qname().startswith('typing.'):
+        raise UseInferenceDefault
 
-def looks_like_typing_namedtuple(node):
-    func = node.func
-    if isinstance(func, nodes.Attribute):
-        return func.attrname == 'NamedTuple'
-    if isinstance(func, nodes.Name):
-        return func.name == 'NamedTuple'
-    return False
+    node = extract_node(TYPING_TYPE_TEMPLATE.format(value.qname().split('.')[-1]))
+    return node.infer(context=context)
 
 
 MANAGER.register_transform(
     nodes.Call,
-    inference_tip(infer_typing_namedtuple),
-    looks_like_typing_namedtuple
+    inference_tip(infer_typing_typevar_or_newtype),
+    looks_like_typing_typevar_or_newtype
 )
-
 MANAGER.register_transform(
-    nodes.ClassDef,
-    inference_tip(infer_typing_namedtuple_class),
-    has_namedtuple_base
+    nodes.Subscript,
+    inference_tip(infer_typing_attr),
+    _looks_like_typing_subscript,
 )
diff -Nru astroid-1.6.5/astroid/builder.py astroid-2.0/astroid/builder.py
--- astroid-1.6.5/astroid/builder.py	2018-06-06 16:59:26.000000000 +0200
+++ astroid-2.0/astroid/builder.py	2018-07-15 09:19:23.000000000 +0200
@@ -1,7 +1,13 @@
+# -*- coding: utf-8 -*-
 # Copyright (c) 2006-2011, 2013-2014 LOGILAB S.A. (Paris, FRANCE) <contact@logilab.fr>
+# Copyright (c) 2013 Phil Schaf <flying-sheep@web.de>
+# Copyright (c) 2014-2018 Claudiu Popa <pcmanticore@gmail.com>
 # Copyright (c) 2014-2015 Google, Inc.
-# Copyright (c) 2014-2016 Claudiu Popa <pcmanticore@gmail.com>
-# Copyright (c) 2015-2016 Cara Vinson <ceridwenv@gmail.com>
+# Copyright (c) 2014 Alexander Presnyakov <flagist0@gmail.com>
+# Copyright (c) 2015-2016 Ceridwen <ceridwenv@gmail.com>
+# Copyright (c) 2016 Derek Gustafson <degustaf@gmail.com>
+# Copyright (c) 2017 Łukasz Rogalski <rogalski.91@gmail.com>
+# Copyright (c) 2018 Anthony Sottile <asottile@umich.edu>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
@@ -12,12 +18,11 @@
 at the same time.
 """
 
-import re
 import os
-import sys
 import textwrap
-import _ast
+from tokenize import detect_encoding
 
+from astroid._ast import _parse
 from astroid import bases
 from astroid import exceptions
 from astroid import manager
@@ -36,45 +41,15 @@
 # when calling extract_node.
 _STATEMENT_SELECTOR = '#@'
 
-
-def _parse(string):
-    return compile(string, "<string>", 'exec', _ast.PyCF_ONLY_AST)
-
-
-if sys.version_info >= (3, 0):
-    from tokenize import detect_encoding
-
-    def open_source_file(filename):
-        with open(filename, 'rb') as byte_stream:
-            encoding = detect_encoding(byte_stream.readline)[0]
-        stream = open(filename, 'r', newline=None, encoding=encoding)
-        data = stream.read()
-        return stream, encoding, data
-
-else:
-    _ENCODING_RGX = re.compile(r"\s*#+.*coding[:=]\s*([-\w.]+)")
-
-    def _guess_encoding(string):
-        """get encoding from a python file as string or return None if not found"""
-        # check for UTF-8 byte-order mark
-        if string.startswith('\xef\xbb\xbf'):
-            return 'UTF-8'
-        for line in string.split('\n', 2)[:2]:
-            # check for encoding declaration
-            match = _ENCODING_RGX.match(line)
-            if match is not None:
-                return match.group(1)
-        return None
-
-    def open_source_file(filename):
-        """get data for parsing a file"""
-        stream = open(filename, 'U')
-        data = stream.read()
-        encoding = _guess_encoding(data)
-        return stream, encoding, data
+MANAGER = manager.AstroidManager()
 
 
-MANAGER = manager.AstroidManager()
+def open_source_file(filename):
+    with open(filename, 'rb') as byte_stream:
+        encoding = detect_encoding(byte_stream.readline)[0]
+    stream = open(filename, 'r', newline=None, encoding=encoding)
+    data = stream.read()
+    return stream, encoding, data
 
 
 def _can_assign_attr(node, attrname):
@@ -83,7 +58,7 @@
     except NotImplementedError:
         pass
     else:
-        if slots and attrname not in set(slot.value for slot in slots):
+        if slots and attrname not in {slot.value for slot in slots}:
             return False
     return True
 
@@ -129,18 +104,18 @@
         try:
             stream, encoding, data = open_source_file(path)
         except IOError as exc:
-            util.reraise(exceptions.AstroidBuildingError(
+            raise exceptions.AstroidBuildingError(
                 'Unable to load file {path}:\n{error}',
-                modname=modname, path=path, error=exc))
+                modname=modname, path=path, error=exc) from exc
         except (SyntaxError, LookupError) as exc:
-            util.reraise(exceptions.AstroidSyntaxError(
+            raise exceptions.AstroidSyntaxError(
                 'Python 3 encoding specification error or unknown encoding:\n'
-                '{error}', modname=modname, path=path, error=exc))
-        except UnicodeError:  # wrong encoding
+                '{error}', modname=modname, path=path, error=exc) from exc
+        except UnicodeError as exc:  # wrong encoding
             # detect_encoding returns utf-8 if no encoding specified
-            util.reraise(exceptions.AstroidBuildingError(
+            raise exceptions.AstroidBuildingError(
                 'Wrong or no encoding specified for {filename}.',
-                filename=path))
+                filename=path) from exc
         with stream:
             # get module name if necessary
             if modname is None:
@@ -182,9 +157,9 @@
         try:
             node = _parse(data + '\n')
         except (TypeError, ValueError, SyntaxError) as exc:
-            util.reraise(exceptions.AstroidSyntaxError(
+            raise exceptions.AstroidSyntaxError(
                 'Parsing Python code failed:\n{error}',
-                source=data, modname=modname, path=path, error=exc))
+                source=data, modname=modname, path=path, error=exc) from exc
         if path is not None:
             node_file = os.path.abspath(path)
         else:
@@ -316,8 +291,7 @@
         yield real_expr
     else:
         for child in node.get_children():
-            for result in _extract_expressions(child):
-                yield result
+            yield from _extract_expressions(child)
 
 
 def _find_statement_by_line(node, line):
@@ -421,10 +395,12 @@
             requested_lines.append(idx + 1)
 
     tree = parse(code, module_name=module_name)
+    if not tree.body:
+        raise ValueError('Empty tree, cannot extract from it')
+
     extracted = []
     if requested_lines:
-        for line in requested_lines:
-            extracted.append(_find_statement_by_line(tree, line))
+        extracted = [_find_statement_by_line(tree, line) for line in requested_lines]
 
     # Modifies the tree.
     extracted.extend(_extract_expressions(tree))
diff -Nru astroid-1.6.5/astroid/context.py astroid-2.0/astroid/context.py
--- astroid-1.6.5/astroid/context.py	2018-06-06 16:59:26.000000000 +0200
+++ astroid-2.0/astroid/context.py	2018-07-15 09:19:22.000000000 +0200
@@ -1,5 +1,7 @@
-# Copyright (c) 2015-2016 Cara Vinson <ceridwenv@gmail.com>
-# Copyright (c) 2015-2016 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2015-2016, 2018 Claudiu Popa <pcmanticore@gmail.com>
+# Copyright (c) 2015-2016 Ceridwen <ceridwenv@gmail.com>
+# Copyright (c) 2018 Bryce Guinta <bryce.paul.guinta@gmail.com>
+# Copyright (c) 2018 Nick Drozd <nicholasdrozd@gmail.com>
 
 # Licensed under the LGPL: https://www.gnu.org/licenses/old-licenses/lgpl-2.1.en.html
 # For details: https://github.com/PyCQA/astroid/blob/master/COPYING.LESSER
@@ -11,30 +13,63 @@
 import pprint
 
 
-class InferenceContext(object):
+class InferenceContext:
     """Provide context for inference
 
     Store already inferred nodes to save time
     Account for already visited nodes to infinite stop infinite recursion
     """
 
-    __slots__ = ('path', 'lookupname', 'callcontext', 'boundnode', 'inferred')
+    __slots__ = ('path', 'lookupname', 'callcontext', 'boundnode', 'inferred', 'extra_context')
 
     def __init__(self, path=None, inferred=None):
         self.path = path or set()
-        """Path of visited nodes and their lookupname
-        :type: set(tuple(NodeNG, optional(str)))"""
+        """
+        :type: set(tuple(NodeNG, optional(str)))
+
+        Path of visited nodes and their lookupname
+
+        Currently this key is ``(node, context.lookupname)``
+        """
         self.lookupname = None
+        """
+        :type: optional[str]
+
+        The original name of the node
+
+        e.g.
+        foo = 1
+        The inference of 'foo' is nodes.Const(1) but the lookup name is 'foo'
+        """
         self.callcontext = None
+        """
+        :type: optional[CallContext]
+
+        The call arguments and keywords for the given context
+        """
         self.boundnode = None
+        """
+        :type: optional[NodeNG]
+
+        The bound node of the given context
+
+        e.g. the bound node of object.__new__(cls) is the object node
+        """
         self.inferred = inferred or {}
         """
         :type: dict(seq, seq)
 
         Inferred node contexts to their mapped results
-        Currently the key is (node, lookupname, callcontext, boundnode)
+        Currently the key is ``(node, lookupname, callcontext, boundnode)``
         and the value is tuple of the inferred results
         """
+        self.extra_context = {}
+        """
+        :type: dict(NodeNG, Context)
+
+        Context that needs to be passed down through call stacks
+        for call arguments
+        """
 
     def push(self, node):
         """Push node into inference path
@@ -61,6 +96,7 @@
         clone = InferenceContext(copy.copy(self.path), inferred=self.inferred)
         clone.callcontext = self.callcontext
         clone.boundnode = self.boundnode
+        clone.extra_context = self.extra_context
         return clone
 
     def cache_generator(self, key, generator):
@@ -87,12 +123,16 @@
         return '%s(%s)' % (type(self).__name__, ',\n    '.join(state))
 
 
-class CallContext(object):
+class CallContext:
     """Holds information for a call site."""
 
     __slots__ = ('args', 'keywords')
 
     def __init__(self, args, keywords=None):
+        """
+        :param List[NodeNG] args: Call positional arguments
+        :param Union[List[nodes.Keyword], None] keywords: Call keywords
+        """
         self.args = args
         if keywords:
             keywords = [(arg.arg, arg.value) for arg in keywords]
@@ -106,3 +146,28 @@
         return context.clone()
 
     return InferenceContext()
+
+
+def bind_context_to_node(context, node):
+    """Give a context a boundnode
+    to retrieve the correct function name or attribute value
+    with from further inference.
+
+    Do not use an existing context since the boundnode could then
+    be incorrectly propagated higher up in the call stack.
+
+    :param context: Context to use
+    :type context: Optional(context)
+
+    :param node: Node to do name lookups from
+    :type node NodeNG:
+
+    :returns: A new context
+    :rtype: InferenceContext
+    """
+    if context is not None:
+        context = context.clone()
+    else:
+        context = InferenceContext()
+    context.boundnode = node
+    return context
